<?php
#==============================================================================================#
#                                   Name  :  Imperial CHAT                                     #
#                               Made by  :  MaZaFaKa (___хакер___)                             #
#                                  MODED :  vipsds  (   BOT  )                                 #
#                                  ICQ  :  350502220 (vipsds)                                  #
#                                E-mai :  vipsds@wapnn.org                                     #
# По всем вопросам и дополнительным модам обращайтесь на выше указанные данные                 #
#==============================================================================================#
//ERROR REPORTING LEVEL
error_reporting(0);
include_once('start.php');
//CONNECTION (MySQL)
include_once('config.php');
//IS USER BANNED?
include('./includes/'.$ver.'/banned');

//GET BOTS NAMES
$bots = file("bots/bots.dat");
$bots[0] = trim($bots[0]);
$bots[1] = trim($bots[1]);
$bots[2] = trim($bots[2]);
$bots[3] = trim($bots[3]); //SYSTEM

//CONFIGS
$configs = file('system/configs.dat');
$adv = $configs[1];
$computer = $configs[2];

//INTERVALS
$intervals = file('bots/intervals.dat');
$intervals[0] = intval($intervals[0]);
$intervals[1] = intval($intervals[1]);
$intervals[2] = intval($intervals[2]);

//VARIABLE FOR NO-CACHE PROTECTION
$nocache = mt_rand(0, 999999999);

list($msec, $sec) = explode(chr(32), microtime());
$headtime = $sec + $msec;

$s = intval($_GET['s']);


switch($ver)
{
////////////////////////////////////////////////////////
//WML VERSION
////////////////////////////////////////////////////////
case 'wml':
header('Content-type:text/vnd.wap.wml; charset=utf-8');
header('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT');
header('Cache-Control: no-cache, must-revalidate');

//AUTH
$id = intval($_SESSION['id']);
$password = mysql_escape_string($_SESSION['password']);
$q = mysql_query("SELECT * FROM `chat_users` WHERE `id` = ".$id." AND `password` = '".md5($password)."';");

if(mysql_affected_rows() == 0)
{
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.3//EN\" \"http://www.wapforum.org/DTD/wml13.dtd\"><wml>\n";
echo "<card title=\"ERROR\" ontimer=\"index.php?ver=wml\"><timer value=\"15\"/><p align=\"left\">\n";
echo "<small>Ошибка авторизации!<br/>\n";
echo "<br/>$wmlfoot";
echo "</small></p></card></wml>";
exit();
}
else
{
$user = mysql_fetch_array($q);
$nickname = $user['nickname'];
$smiles = $user['smiles'];
$translit  = $user['translit'];
$msgs  = $user['msgs'];
$refresh = $user['refresh'];
$fsize = $user['fsize'];
$security  = $user['security'];
$level = $user['level'];
$kick = $user['kick'];
$moder = $user['moder'];
$reason = $user['reason'];
$refresh = $refresh * 10;
$emotions = $user['emotions'];
$buttons = $user['sftky'];
$ip = $user['ip'];
$ua = $user['ua'];
$security = $user['security'];
}
//END AUTH

if(((strpos($ua, "Opera") !== false) or (strpos($ua, "Mozilla") !== false) or (strpos($ua, "MSIE") !== false)  or (strpos($ua, "Netscape") !== false)) && $computer == 1 && $level == 0)
{
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.3//EN\" \"http://www.wapforum.org/DTD/wml13.dtd\"><wml>\n";
echo "<card title=\"ERROR\" ontimer=\"/menu/wml\"><timer value=\"10\"/><p align=\"left\">\n";
echo "<small>Доступ с компьютера запрещен.<br/>\n";
echo "<br/>$wmlfoot";
echo "</small></p></card></wml>";
exit();
}

$rid = intval($_GET['rid']);

$sql = mysql_query("SELECT `topic`, `type` FROM `chat_rooms` WHERE `id` = ".$rid);

if(mysql_num_rows($sql) == 0)
{
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.3//EN\" \"http://www.wapforum.org/DTD/wml13.dtd\"><wml>\n";
echo "<card title=\"Ошибка\" ontimer=\"/menu/wml\"><timer value=\"10\"/><p align=\"left\">\n";
echo "<small>Такой комнаты не существует.<br/>\n";
echo "<br/>$wmlfoot";
echo "</small></p></card></wml>";
exit();
}
else
{
$topic = mysql_result($sql, 0, 'topic');
$type = mysql_result($sql, 0, 'type');
}

if($level == 0 && $type == 1)
{
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.3//EN\" \"http://www.wapforum.org/DTD/wml13.dtd\"><wml>\n";
echo "<card title=\"Ошибка\" ontimer=\"/menu/wml\"><timer value=\"10\"/><p align=\"left\">\n";
echo "<small>Доступ запрещен.<br/>\n";
echo "<br/>$wmlfoot";
echo "</small></p></card></wml>";
exit();
}

if($kick > time() && (($rid != $wicked_quiz && $rid != $unlim) or $moder == $bots[3]))
{
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.3//EN\" \"http://www.wapforum.org/DTD/wml13.dtd\"><wml>\n";
echo "<card title=\"Ошибка\" ontimer=\"/rules/wml\"><timer value=\"50\"/><p align=\"left\">\n";
echo "<small>Вы забаненны модератором <u>$moder</u> на <u>".($kick - time())."</u> сек.<br/>\n";
echo "Причина: $reason<br/>\n";
echo "<br/>$wmlfoot";
echo "</small></p></card></wml>";
exit();
}

//ONLINE
$online = time() + 90;
$update = mysql_query("UPDATE `chat_users` SET `time` = ".$online.", `place` = ".$rid.", `ip` = '".getenv('REMOTE_ADDR')."', `ua` = '".htmlspecialchars(getenv('HTTP_USER_AGENT'))."' WHERE `id` = ".$id);
//END ONLINE
if(strpos($buttons, "5") !== false) {
$sql = mysql_query("SELECT COUNT(*) FROM `chat_letters` WHERE `to` = ".$id." AND `read` = 0 AND `id` = ".$id);
$inbox = mysql_result($sql, 0);
}
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
echo "<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.3//EN\" \"http://www.wapforum.org/DTD/wml13.dtd\"><wml>\n";
echo "<head><meta http-equiv=\"Cache-Control\" content=\"no-cache\" forua=\"true\"/></head>\n";
echo "<card id=\"chat\" title=\"История\">";
echo "<p align=\"left\">";
echo" <br/><br/>";
include "bots/joker.php";

if($rid == 1)
{
include "bots/bot.php";
mysql_query("UPDATE `chat_users` SET `time` = ".$online.", `place` = 1 WHERE `id` = 3;");
}

if($rid == 3)
{
include "bots/boor.php";
include "bots/second_bot.php";
mysql_query("UPDATE `chat_users` SET `time` = ".$online.", `place` = 3 WHERE `id` = 4;");
}

if($fsize == 0)
{
$open_tag = "<small>";
$close_tag = "</small>";
}
if($fsize == 1)
{
$open_tag = "";
$close_tag = "";
}
if($fsize == 2)
{
$open_tag = "<big>";
$close_tag = "</big>";
}

echo $open_tag;
if($security == 1 && ($ip != getenv('REMOTE_ADDR') OR $ua != htmlspecialchars(getenv('HTTP_USER_AGENT'))))
{
echo'Ваш текущий IP и телефон не совпадают с теми, что использовались в последний раз. Предыдущий IP: '.getenv('REMOTE_ADDR').', предыдущий телефон: '.getenv('HTTP_USER_AGENT').'.<br/>';
$online = time() + 60;
mysql_query("UPDATE `chat_users` SET `time` = '".$online."', `place` = 0, `ip` = '".getenv('REMOTE_ADDR')."', `ua` = '".htmlspecialchars(getenv('HTTP_USER_AGENT'))."' WHERE `id` = '".$id."';");
}

if(isset($_POST['msg']))
{
mysql_query("SELECT * FROM `chat".$rid."` WHERE `aid` = '".$id."' AND `seconds` > ".(time() - 20).";");
if(mysql_affected_rows() > 3)
{
$reason = "Вы были автоматически забанены системой за флуд (многократное повторение сообщений).";
mysql_query("UPDATE `chat_users` SET `kick` = ".(time() + 180).", `moder` = '".$bots[3]."', `reason` = '".$reason."' WHERE `id` = '".$id."';");
}

$msg = trim($_POST['msg']);

if(isset($_POST['uid']))
{
$sql = mysql_query("SELECT `nickname` FROM `chat_users` WHERE `id` = ".intval($_POST['uid']).";");
$nick = mysql_result($sql, 0);
}
else
{
$nick = "";
}

$msg = stripslashes($msg);

	if($_POST['translit'] == "true")
	{
	$msg = str_replace("\"", "ъ", $msg);
	$msg = str_replace("'", "ь", $msg);

	$lat = array("CH", "ch", "SC", "sc", "YE", "ye", "YU", "yu", "YA", "ya", "YO", "yo");
	$rus = array("Ч", "ч", "Щ", "щ", "Э", "э", "Ю", "ю", "Я", "я", "Ё", "ё");
	$msg = str_replace($lat, $rus, $msg);

	$lat = array("A", "a", "B", "b", "C", "c", "D", "d", "E", "e", "F", "f", "G", "g", "H", "h", "I", "i", "J", "j", "K", "k", "L", "l", "M", "m", "N", "n", "O", "o", "P", "p", "R", "r", "S", "s", "T", "t", "U", "u", "V", "v", "H", "h", "Z", "z", "W", "w", "X", "x", "Y", "y");
	$rus = array("А", "а", "Б", "б", "Ц", "ц", "Д", "д", "Е", "е", "Ф", "ф", "Г", "г", "Х", "х", "И", "и", "Ж", "ж", "К", "к", "Л", "л", "М", "м", "Н", "н", "О", "о", "П", "п", "Р", "р", "С", "с", "Т", "т", "У", "у", "В", "в", "Х", "х", "З", "з", "Ш", "ш", "Ы", "ы", "Й", "й");
	$msg = str_replace($lat, $rus, $msg);
	}

$msg = htmlspecialchars($msg);






$msg = iconv_substr($msg, 0, 1024, 'utf-8');
$msg = str_replace("$", "$$", $msg);

//ubiranie reklamy
if($adv == 1 && $level < 4)
{
$msg = eregi_replace("((([a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z;]{2,3}))|(([0-9]{1,3}\.){3}([0-9]{1,3})))((/|\?)[a-z0-9~#%&'_\+=:;\?\.-]*)*)", "censored", $msg);
}

if($level == 4)
{
$msg = preg_replace("|\*\((.*)\)\*|isU", "<b>\\1</b>", $msg);
}

$msg = mysql_escape_string($msg);

$sql = mysql_query("SELECT `msg` FROM `chat".$rid."` WHERE `aid` = '".$id."' ORDER BY `id` DESC LIMIT 1;");
$last_msg = mysql_escape_string(mysql_result($sql, 0));

	if($last_msg != $msg && !empty($msg))
	{
	$to = (int)$_POST['to'];
	$sql = mysql_query("INSERT INTO `chat".$rid."` VALUES(0, '".$id."', '".$nickname."', '".$msg."', '".$to."', '".date("H:i")."',".time().",".intval($_POST['uid']).");");
		/*if(mysql_insert_id() > 4000000000)
		{
		mysql_query("TRUNCATE TABLE `chat".$rid."`;");
		$message = "Комната была очищена системой. Данная операция была важна для снятия нагрузки с базы данных.";
		$sql = mysql_query("SELECT `id` FROM `chat_rooms`;");
			while($room_id = mysql_fetch_array($sql))
			{
			mysql_query("INSERT INTO `chat".$rid."` VALUES(0, '5', '".$bots[3]."', '".$message."', '0', '".date("H:i")."',".time().",".intval($_POST['uid']).");");
			}
		}
		if(!$sql)
		{
		$sql = mysql_query("INSERT INTO `chat".$rid."` VALUES(0, '".$id."', '".$nickname."', '".$msg."', '".$to."', '".date("H:i")."', ".time().",".intval($_POST['uid']).");");
		}
		*/
	mysql_query("UPDATE `chat_users` SET `posts` = `posts` + 1 WHERE `id` = ".$id);
	if($rid == 1) include "bots/answer.php";
	if($rid == 3) include "bots/second_answer.php";
	}
}

$sql = mysql_query("SELECT COUNT(*) FROM `chat".$rid."`;");
$all = mysql_result($sql, 0);




if(!$_GET['s'])
{$s=0;}


$ignor = '';

$sql = mysql_query("SELECT * FROM `chat_ignor` WHERE `id` = ".$id);
while($ignor_arr = mysql_fetch_assoc($sql))
{
$ignor .= " `aid` != '".$ignor_arr['uid']."' AND ";
}


if($id != 1) $sql = mysql_query("SELECT * FROM `chat".$rid."` WHERE ".$ignor." (`to` = 0 OR `to` = '".$id."' OR `aid` = '".$id."') ORDER BY `id` DESC LIMIT $s, $msgs;");
else $sql = mysql_query("SELECT * FROM `chat".$rid."` WHERE ".$ignor." `aid` != 0 ORDER BY `id` DESC LIMIT $s, $msgs;");
while($post = mysql_fetch_array($sql))
{

//text
$q = mysql_query("SELECT * FROM `chat_users` WHERE `id` = ".$post['aid']);
$lvv = mysql_fetch_array($q);
//SMILES
include "includes/smiles_array/all.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);

if($lvv['posts'] > 0)
{
include "includes/smiles_array/polzovatel.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
if($lvv['posts'] >= 3000)
{
include "includes/smiles_array/chatter.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
if($lvv['posts'] >= 8000)
{
include "includes/smiles_array/smiles_person.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
if($lvv['level'] != 0)
{
include "includes/smiles_array/moder.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
if($lvv['level'] == 4)
{
include "includes/smiles_array/admin.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
//
$post['msg'] = str_replace("<font color=red>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=blue>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=#008000>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=gray>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=#FFA500>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=#0066FF>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=#228B22>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=#D02090>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=#B03060>"," ",$post['msg']);
$post['msg'] = str_replace("<font color=#8A2BE2>"," ",$post['msg']);
$post['msg'] = str_replace("</font>"," ",$post['msg']);

if($lvv['level'] != 0)
{
include "includes/text_array/wml_info.php";
$post['msg'] = preg_replace($search, $replace, $post['msg']);
}
echo "[".$post['time']."] <a href=\"/info/wml/$rid/$nocache/".$post['aid']."\">".$lvv['nickname']."</a> >\n";
$post['msg'] = stripslashes($post['msg']);
if($smiles == 0) $post['msg'] = preg_replace("|<img[^>]+>|isU", "*smile*", $post['msg']);
$post['msg'] = str_replace("<usersid>", SID, $post['msg']);
//Tonickname
$qm = mysql_query("SELECT `nickname` FROM `chat_users` WHERE `id` ='".$post[tonick]."';");
$tonick = mysql_result($qm, 0);
if($nickname == $tonick)
{
$tonick = "<b>$tonick</b>";
}
if($post[tonick] != 0)
{
echo $tonick.", \n";
}
if($post['to'] != 0)
{
echo "<b>[P!]\n</b>";
}
echo $post['msg']."<br/>\n";
}
echo'<small>';
$counter = $all;
$max_mess=$msgs;
$s= $_GET['s'];
if(!$_GET['s'])
{$s=0;}
if($counter>0){
$ba=ceil($s/$max_mess);
$ba2=$ba*$max_mess-$s;
$asd=$s-($max_mess*3);
$asd2=$s+($max_mess*5);
if($asd<$counter && $asd>0){echo ' <a href="/history/wml/'.$rid.'/0/'.$nocache.'">1</a> ... ';}
for($i=$asd; $i<$asd2;)
{
  if($i<$counter && $i>=0)
  {
   $ii=floor(1+$i/$max_mess);
   if ($s==$i)
   {
   echo $ii;
   }
                else
                {
                echo ' <a href="/history/wml/'.$rid.'/'.$i.'/'.$nocache.'">['.$ii.']</a>';
                }

  }
$i=$i+$max_mess;}
if($asd2<$counter){echo ' ... ';}
}
echo'</small>';
echo "<br/><br/>";
echo "• <a href=\"/room/wml/$rid/$nocache\">В чат</a><br/>\n";
echo "• <a href=\"/online/wml\">Кто где?</a><br/>\n";
echo '• <a href="/menu/wml/'.$nocache.'">В прихожую</a><br/>';

echo $close_tag;

echo "</p></card><card id=\"add\" title=\"Сказать\"><p align=\"left\">";
echo "<input type=\"text\" name=\"msg$nocache\" maxlength=\"300\" value=\"\"/><br/>\n";
if($translit == 1)
{
echo "Транслитировать:<br/>\n";
echo "<select name=\"translit$nocache\" value=\"true\">\n";
echo "<option value=\"true\">Да</option>\n";
echo "<option value=\"false\">Нет</option>\n";
echo "</select><br/>\n";
}
echo "<anchor>Сказать<go href=\"/room/wml/$rid/$nocache\" method=\"post\">\n";
echo "<postfield name=\"msg\" value=\"$(msg$nocache)\"/>\n";
echo "<postfield name=\"translit\" value=\"$(translit$nocache)\"/>\n";
echo "</go></anchor><br/>\n";
echo "• <a href=\"room/wml/$rid/$nocache\">В чат</a><br/>\n";
echo "</p></card></wml>";
break;

////////////////////////////////////////////////////////
//HTML VERSION
////////////////////////////////////////////////////////
case 'html':
header ("Content-type: text/html; charset=utf-8");
header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
header("Cache-Control: no-cache, must-revalidate");

//AUTH
$id = intval($_SESSION['id']);
$password = mysql_escape_string($_SESSION['password']);
$q = mysql_query("SELECT * FROM `chat_users` WHERE `id` = ".$id." AND `password` = '".md5($password)."';");

if(mysql_affected_rows() == 0)
{
echo $css;
echo'<title>'.$ttl.'</title>';
echo'<div class="d3">Ошибка</div>';
echo "<div class=\"d5\">Ошибка авторизации!</div>\n";
echo'<div class="d3">';
echo $sitefoot;
echo'</div>';
echo "</body></html>";
exit();
}
else
{
$user = mysql_fetch_assoc($q);
$nickname = $user['nickname'];
$smiles = $user['smiles'];
$translit  = $user['translit'];
$msgs  = $user['msgs'];
$refresh = $user['refresh'];
$fsize = $user['fsize'];
$ip = $user['ip'];
$ua = $user['ua'];
$security = $user['security'];
$level = $user['level'];
$kick = $user['kick'];
$moder = $user['moder'];
$reason = $user['reason'];
}
//END AUTH

if(((strpos($ua, "Opera") !== false) or (strpos($ua, "Mozilla") !== false) or (strpos($ua, "MSIE") !== false)  or (strpos($ua, "Netscape") !== false)) && $computer == 1 && $level == 0)
{
echo "$css";
echo'<title>'.$ttl.'</title>';
echo'<div class="d3">Ошибка</div>';
echo "<div class=\"d5\">Доступ с компьютера запрещен.</div>\n";
echo'<div class="d3">';
echo"$sitefoot";
echo'</div>';
echo "</body></html>";
exit();
}

$rid = intval($_GET['rid']);

$sql = mysql_query("SELECT `topic`, `type` FROM `chat_rooms` WHERE `id` = ".$rid);

if(mysql_num_rows($sql) == 0)
{
echo $css;
echo'<title>'.$ttl.'</title>';
echo'<div class="d3">Ошибка</div>';
echo "<div class=\"d5\">Такой комнаты не существует.</div>\n";
echo'<div class="d3">';
echo"$sitefoot";
echo'</div>';
echo "</body></html>";
exit();
}
else
{
$topic = mysql_result($sql, 0, 'topic');
$type = mysql_result($sql, 0, 'type');
}

if($level == 0 && $type == 1)
{
echo $css;
echo'<title>'.$ttl.'</title>';
echo'<div class="d3">Ошибка</div>';
echo "<div class=\"d5\">Доступ запрещен.</div>\n";
echo'<div class="d3">';
echo $sitefoot;
echo'</div>';
echo "</body></html>";
exit();
}

if($kick > time() && ($rid != $wicked_quiz && $rid != $unlim))
{
echo $css;
echo'<title>'.$ttl.'</title>';
echo'<div class="d3">Ошибка</div>';
echo'<div class="d5">';
echo "Вы забаненны модератором <u>$moder</u> на <u>".($kick - time())."</u> сек.<br/>\n";
echo "Причина: $reason</div>\n";
echo'<div class="d3">';
echo $sitefoot;
echo'</div>';
echo "</body></html>";
exit();
}

//ONLINE
$online = time() + 90;
$update = mysql_query("UPDATE `chat_users` SET `time` = ".$online.", `place` = ".$rid.", `ip` = '".getenv('REMOTE_ADDR')."', `ua` = '".mysql_escape_string(htmlspecialchars(getenv('HTTP_USER_AGENT')))."' WHERE `id` = ".$id);
//END ONLINE

if($fsize == 0)
{
$fsize = "small";
}
if($fsize == 1)
{
$fsize = "normal";
}
if($fsize == 2)
{
$fsize = "large";
}


echo $css;
echo'<title>История</title>';
echo'<div class="d3">История</div>';
if($security == 1 && ($ip != getenv('REMOTE_ADDR') OR $ua != htmlspecialchars(getenv('HTTP_USER_AGENT'))))
{
echo'</div>';
echo'<div class="d2">';
echo'Ваш текущий IP и телефон не совпадают с теми, что использовались в последний раз. Предыдущий IP: '.getenv('REMOTE_ADDR').', предыдущий телефон: '.getenv('HTTP_USER_AGENT').'.';
echo'</div>';
$online = time() + 60;
mysql_query("UPDATE `chat_users` SET `time` = '".$online."', `place` = 0, `ip` = '".getenv('REMOTE_ADDR')."', `ua` = '".mysql_escape_string(htmlspecialchars(getenv('HTTP_USER_AGENT')))."' WHERE `id` = ".$id);
}
include "bots/joker.php";

if($rid == 1)
{
include "bots/bot.php";
mysql_query("UPDATE `chat_users` SET `time` = ".$online.", `place` = 1 WHERE `id` = 2;");
}

if($rid == 3)
{
include "bots/boor.php";
include "bots/second_bot.php";
mysql_query("UPDATE `chat_users` SET `time` = ".$online.", `place` = 3 WHERE `id` = 4;");
}
if(isset($_POST['msg']))
{
mysql_query("SELECT * FROM `chat".$rid."` WHERE `aid` = ".$id." AND `seconds` > ".(time() - 20));
if(mysql_affected_rows() > 3)
{
$reason = "Вы были автоматически забанены системой за флуд (многократное повторение сообщений).";
mysql_query("UPDATE `chat_users` SET `kick` = ".(time() + 180).", `moder` = '".$bots[3]."', `reason` = '".$reason."' WHERE `id` = '".$id."';");
}

$msg = trim($_POST['msg']);

if(isset($_POST['uid']))
{
$sql = mysql_query("SELECT `nickname` FROM `chat_users` WHERE `id` = ".intval($_POST['uid']));
$nick = mysql_result($sql, 0);
}
else
{
$nick = "";
}

$msg = stripslashes($msg);

	if($_POST['translit'] == "true")
	{
	$msg = str_replace('""', "Ъ", $msg);
	$msg = str_replace('"', "ъ", $msg);
	$msg = str_replace("''", "Ь", $msg);
	$msg = str_replace("'", "ь", $msg);

	$lat = array("CH", "ch", "SC", "sc", "YE", "ye", "YU", "yu", "YA", "ya", "YO", "yo");
	$rus = array("Ч", "ч", "Щ", "щ", "Э", "э", "Ю", "ю", "Я", "я", "Ё", "ё");
	$msg = str_replace($lat, $rus, $msg);

	$lat = array("A", "a", "B", "b", "C", "c", "D", "d", "E", "e", "F", "f", "G", "g", "H", "h", "I", "i", "J", "j", "K", "k", "L", "l", "M", "m", "N", "n", "O", "o", "P", "p", "R", "r", "S", "s", "T", "t", "U", "u", "V", "v", "H", "h", "Z", "z", "W", "w", "X", "x", "Y", "y");
	$rus = array("А", "а", "Б", "б", "Ц", "ц", "Д", "д", "Е", "е", "Ф", "ф", "Г", "г", "Х", "х", "И", "и", "Ж", "ж", "К", "к", "Л", "л", "М", "м", "Н", "н", "О", "о", "П", "п", "Р", "р", "С", "с", "Т", "т", "У", "у", "В", "в", "Х", "х", "З", "з", "Ш", "ш", "Ы", "ы", "Й", "й");
	$msg = str_replace($lat, $rus, $msg);
	}

$msg = htmlspecialchars($msg);



$msg = iconv_substr($msg, 0, 1024, 'utf-8');
$msg = str_replace('$', '$$', $msg);

if($adv == 0 && $level < 4)
{
$msg = eregi_replace("((([a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z;]{2,3}))|(([0-9]{1,3}\.){3}([0-9]{1,3})))((/|\?)[a-z0-9~#%&'_\+=:;\?\.-]*)*)", "censored", $msg);
}

if($level == 4)
{
$msg = preg_replace("|\*\((.*)\)\*|isU", "<b>\\1</b>", $msg);
}

$msg = mysql_escape_string($msg);

$sql = mysql_query("SELECT `msg` FROM `chat".$rid."` WHERE `aid` = ".$id." ORDER BY `id` DESC LIMIT 1;");
$last_msg = mysql_escape_string(mysql_result($sql, 0));

	if($last_msg != $msg && !empty($msg))
	{
	$to = (int)$_POST['to'];
	$sql = mysql_query("INSERT INTO `chat` VALUES(0, '".$id."', '".$nickname."', '".$msg."', '".$rid."', '".$to."', '".date("H:i")."',".time().",".intval($_POST['uid']).");");
		/*if(mysql_insert_id() > 4000000000)
		{
		mysql_query("TRUNCATE TABLE `chat".$rid."`;");
		$message = "Комната была очищена системой. Данная операция была важна для снятия нагрузки с базы данных.";
		$sql = mysql_query("SELECT `id` FROM `chat_rooms`;");
			while($room_id = mysql_fetch_array($sql))
			{
			mysql_query("INSERT INTO `chat".$rid."` VALUES(0, '5', '".$bots[3]."', '".$message."', '0', '".date("H:i")."',".time().",".intval($_POST['uid']).");");
			}
		}
		if(!$sql)
		{
		$sql = mysql_query("INSERT INTO `chat".$rid."` VALUES(0, '".$id."', '".$nickname."', '".$msg."', '".$to."', '".date("H:i")."', ".time().",".intval($_POST['uid']).");");
		}
		*/
	mysql_query("UPDATE `chat_users` SET `posts` = `posts` + 1 WHERE `id` = ".$id);
	if($rid == 1) include "bots/answer.php";
	if($rid == 3) include "bots/second_answer.php";
	}
}

$sql = mysql_query("SELECT COUNT(*) FROM `chat".$rid."`;");
$all = mysql_result($sql, 0);
$ignor = "";

$sql = mysql_query("SELECT * FROM `chat_ignor` WHERE `id` = ".$id);
while($ignor_arr = mysql_fetch_array($sql))
{
$ignor .= " `aid` != '".$ignor_arr['uid']."' AND ";
}
if(!$_GET['s'])
{$s=0;}
if($id != 1) $sql = mysql_query("SELECT * FROM `chat".$rid."` WHERE ".$ignor." (`to` = 0 OR `to` = '".$id."' OR `aid` = '".$id."') ORDER BY `id` DESC LIMIT $s ,$msgs");
else $sql = mysql_query("SELECT * FROM `chat".$rid."` WHERE ".$ignor." `aid` != 0 ORDER BY `id` DESC LIMIT $s ,$msgs");

$c = 0;

while($post = mysql_fetch_array($sql))
{
if($c == 0)
{
$div = "";
$close = "";
$c = 1;
}
else
{
$div = "";
$close = "";
$c = 0;
}

/////NICKNAMECOLOR
$q = mysql_query("SELECT * FROM `chat_users` WHERE `id` = ".$post['aid']);
$lvv = mysql_fetch_array($q);
/////////////////////////Nickcolor
if($lvv['colornick'])
{
$lvv['nickname']="<font color=\"#".$lvv['colornick']."\">".$lvv['nickname']."</font>";
}

//SMILES
include "includes/smiles_array/all.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
include "includes/smiles_array/bystrye.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
if($lvv['posts'] > 0)
{
include "includes/smiles_array/polzovatel.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
if($lvv['level'] > 3 or $lvv['posts'] >= 3000)
{
include "includes/smiles_array/chatter.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
if($lvv['level'] > 3 or $lvv['posts'] >= 8000)
{
include "includes/smiles_array/smiles_person.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
if($lvv['level'] != 0)
{
include "includes/smiles_array/moder.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
if($lvv['level'] > 3)
{
include "includes/smiles_array/admin.php";
$post['msg'] = preg_replace($smiles_array, $smile, $post['msg'], 2);
}
//




 if($lvv['id'] == 15)
 {
 $lvv['nickname']=$lvv['nickname'];
 }


 if($lvv['nickname'] == $nickname)
 {
 $post['tonick']=$post['tonick'];
 }



  if($lvv['level'] != 9)
  {
  include "includes/text_array/moder_tegi.php";
  $post['msg'] = preg_replace($search, $replace, $post['msg']);
  }



echo "<u>[".$post['time']."]</u> <a href=\"/info/html/$rid/$nocache/".$post['aid']."\">".$lvv['nickname']."</a> ";


$post['msg'] = str_replace('$$', '$', $post['msg']);
$post['msg'] = stripslashes($post['msg']);
if($smiles == 0) $post['msg'] = preg_replace("|<img[^>]+>|isU", "*smile*", $post['msg']);
$post['msg'] = str_replace("<usersid>", SID, $post['msg']);
//Tonickname
$qm = mysql_query("SELECT `nickname` FROM `chat_users` WHERE `id` ='".$post[tonick]."';");
$tonick = mysql_result($qm, 0);
if($nickname == $tonick)
{
$tonick = "<b>$tonick</b>";
}
if($post[tonick] != 0)
{
echo $tonick.", \n";
}
if($post['to'] != 0)
{
echo "<b>[P!]\n</b>";
}
echo $post['msg']."<br/>\n";
}
echo'<div class="d2">';
$counter = $all;
$max_mess=$msgs;
$s= $_GET['s'];
if(!$_GET['s'])
{$s=0;}
if($counter>0){
$ba=ceil($s/$max_mess);
$ba2=$ba*$max_mess-$s;
$asd=$s-($max_mess*3);
$asd2=$s+($max_mess*5);
if($asd<$counter && $asd>0){echo ' <a href="/history/html/'.$rid.'/0/'.$nocache.'">1</a> ... ';}
for($i=$asd; $i<$asd2;)
{
if($i<$counter && $i>=0){
$ii=floor(1+$i/$max_mess);
if ($s==$i) {
echo ''.$ii.'';
               }
                else {
                echo ' <a href="/history/html/'.$rid.'/'.$i.'/'.$nocache.'">['.$ii.']</a>';
                     }}
$i=$i+$max_mess;}
if($asd2<$counter){echo ' ... ';}
}
//
echo'</div>';
echo'<div class="d1">';
echo "• <a href=\"/room/html/$rid/$nocache\">В чат</a><br/>\n";
echo "• <a href=\"/online/html\">Кто где?</a><br/>\n";
echo '• <a href="/menu/html/'.$nocache.'">В прихожую</a><br/>';
echo"</div>";
echo'<div class="d3">';
echo $sitefoot;
echo'</div>';
echo "</body></html>";
break;
}
?>